#version 110

uniform sampler2D renderSampler;
uniform sampler2D randomSampler;
uniform float bloomAlpha;
uniform float texAspect;
uniform vec2 maximums;
uniform vec2 units;

uniform vec2 samples1[9];
uniform vec2 samples2[9];

void main()
{
	vec2 texCoord = vec2(gl_TexCoord[0]);
   	
   	vec2 len = vec2(0.0025)*vec2(1.0, texAspect);
   	
   	vec3 colorSum = vec3(0.0);
    
    vec2 random2 = normalize(texture2D(randomSampler, gl_FragCoord.xy/vec2(2.0)).xy - vec2(0.5));

    int index;
	for(index = 0; index < 9; index += 1)
    {
	    vec2 offset2 = len*reflect(samples2[index], random2);
	    colorSum += texture2D(renderSampler, min(texCoord+offset2, maximums)).rgb;
	}
    colorSum = colorSum*0.35*bloomAlpha;
	
	vec3 origColor = texture2D(renderSampler, texCoord).rgb;
    float val = min(dot(origColor, vec3(1.0, 2.0, 1.0)), 3.0);
     
    gl_FragColor.rgb = vec3(0.5 + colorSum);
    gl_FragColor.a = gl_Color.a;
}