#version 110

uniform sampler2D renderSampler;
uniform sampler2D halfSampler;
uniform float bloomAlpha;
uniform float texAspect;
uniform vec2 maximums;
uniform vec2 units;

void main()
{
	vec2 texCoord0 = vec2(gl_TexCoord[0]);
	vec2 texCoord1 = vec2(gl_TexCoord[1]);
    
    vec3 blur = texture2D(halfSampler,			 texCoord1 + units * vec2(0, -3)).rgb;
    
    blur += texture2D(halfSampler, 				 texCoord1 + units * vec2(-1, -2)).rgb;
    blur += texture2D(halfSampler, min(maximums, texCoord1 + units * vec2(2, -1))).rgb;
    
    
    blur += texture2D(halfSampler, 				 texCoord1 + units * vec2(-3, 0)).rgb;
    blur += texture2D(halfSampler, 				 texCoord1).rgb;
    blur += texture2D(halfSampler, min(maximums, texCoord1 + units * vec2(3, 0))).rgb;
    
    
    blur += texture2D(halfSampler, min(maximums, texCoord1 + units * vec2(-2, 1))).rgb;
    blur += texture2D(halfSampler, min(maximums, texCoord1 + units * vec2(1, 2))).rgb;
    
    blur += texture2D(halfSampler, min(maximums, texCoord1 + units * vec2(0, 3))).rgb;
    
    vec3 origColor = texture2D(renderSampler, texCoord0).rgb;
    #ifdef NO_BLOOM
	origColor.rgb = origColor.rgb*(bloomAlpha*2.0+1.0);
    #endif
    gl_FragColor.rgb = origColor + blur/9.0 - 0.5;
    gl_FragColor.a = gl_Color.a;
}
	